diff --git a/miniupnpd/netfilter_nft/nftnlrdr.c b/miniupnpd/netfilter_nft/nftnlrdr.c
index 51c525f2..9ef2881d 100644
--- a/miniupnpd/netfilter_nft/nftnlrdr.c
+++ b/miniupnpd/netfilter_nft/nftnlrdr.c
@@ -449,12 +449,13 @@ get_peer_rule_by_index(int index,
 		       u_int64_t * packets, u_int64_t * bytes)
 {
 	rule_t *r;
+	int i = 0;
 
 	d_printf(("get_peer_rule_by_index()\n"));
 	refresh_nft_cache_peer();
 
 	LIST_FOREACH(r, &head_peer, entry) {
-		if (r->index == index) {
+		if (i++ == index) {
 			if (ifname != NULL) {
 				if_indextoname(r->ingress_ifidx, ifname);
 			}
@@ -551,12 +552,13 @@ get_redirect_rule_by_index(int index,
 			   u_int64_t * packets, u_int64_t * bytes)
 {
 	rule_t *r;
+	int i = 0;
 
 	d_printf(("get_redirect_rule_by_index()\n"));
 	refresh_nft_cache_redirect();
 
 	LIST_FOREACH(r, &head_redirect, entry) {
-		if (r->index == index) {
+		if (i++ == index) {
 			if (ifname != NULL) {
 				if_indextoname(r->ingress_ifidx, ifname);
 			}
diff --git a/miniupnpd/netfilter_nft/nftnlrdr_misc.c b/miniupnpd/netfilter_nft/nftnlrdr_misc.c
index 1cf53d60..4edc91ad 100644
--- a/miniupnpd/netfilter_nft/nftnlrdr_misc.c
+++ b/miniupnpd/netfilter_nft/nftnlrdr_misc.c
@@ -483,11 +483,8 @@ table_cb(const struct nlmsghdr *nlh, void *data)
 	struct nftnl_expr_iter *itr;
 	rule_t *r;
 	char *chain;
-	int index_filter, index_peer, index_redirect;
 	UNUSED(data);
 
-	index_filter = index_peer = index_redirect = 0;
-
 	r = malloc(sizeof(rule_t));
 
 	if (r == NULL) {
@@ -547,22 +544,16 @@ table_cb(const struct nlmsghdr *nlh, void *data)
 					case RULE_NAT:
 						switch (r->nat_type) {
 						case NFT_NAT_SNAT:
-							r->index = index_peer;
 							LIST_INSERT_HEAD(&head_peer, r, entry);
-							index_peer++;
 							break;
 						case NFT_NAT_DNAT:
-							r->index = index_redirect;
 							LIST_INSERT_HEAD(&head_redirect, r, entry);
-							index_redirect++;
 							break;
 						}
 						break;
 
 					case RULE_FILTER:
-						r->index = index_filter;
 						LIST_INSERT_HEAD(&head_filter, r, entry);
-						index_filter++;
 						break;
 
 					default:
diff --git a/miniupnpd/netfilter_nft/nftnlrdr_misc.h b/miniupnpd/netfilter_nft/nftnlrdr_misc.h
index e60d40e6..dbb168f8 100644
--- a/miniupnpd/netfilter_nft/nftnlrdr_misc.h
+++ b/miniupnpd/netfilter_nft/nftnlrdr_misc.h
@@ -75,7 +75,6 @@ typedef struct rule_t {
 	uint64_t bytes;
 	char * desc;
 	uint32_t desc_len;
-	int index;
 } rule_t;
 
 LIST_HEAD(rule_list, rule_t);
